CATCosinor <-
function (TimeCol=1,Y=2, Components=1, window="noTaper", RefDateTime=NA,  timeFormat="%Y%m%d%H%M", RangeDateTime=list(Start=NA, End=NA), Units="hours", dt=0, Progressive=list(Interval=0, Increment=0), Period=list(Set=0,Start=0,Increment=1,End=0),header=FALSE, Skip=0, Colors="BW",Graphics="pdf",Output=list(Txt=FALSE,Dat=TRUE, Doc=TRUE,Graphs=FALSE,bySubject=FALSE),yLabel="", Console=FALSE,Debug=FALSE,IDcol="fileName", fileName=fileName,functionName="") {    #GraphSet is another parameter used to override proper graphics
  tz="GMT"
  if (IDcol=="fileName"){
    Output$bySubject=FALSE
    cat("IDCol == fileName, so data  is not analyzed by Subject.  (Change IDCol to a column name for analysis by Subject.")
    CATCosinorMain(TimeCol=TimeCol,Y=Y, Components=Components, window=window, RefDateTime=RefDateTime,  timeFormat=timeFormat, RangeDateTime=RangeDateTime, Units=Units, dt=dt, Progressive=Progressive, Period=Period,header=header, Skip=Skip, Colors=Colors,Graphics=Graphics,Output=Output,Console=Console,Debug=Debug,IDcol=IDcol,fileName=fileName,functionName=functionName)
  } else {
    
    if (length(fileName)==0){
      fileName <- file.choose()
    }
    # extract filename from path for display on output 
      newNames<-fileBase(fileName,functionName)
      #browser()
      #return(list(Name=fileName1,Txt=fileName2,Rtf=fileName3,Path=fileName6))
      fileName1<-unlist(newNames[1])  #  data fileName.ext
      fileName2<-unlist(newNames[2])  #  output file:  fileName.txt  (uses data fileName)
      fileName3<-unlist(newNames[3])  #  output file:  fileName.rtf  (uses data fileName)
      fileName5<-unlist(newNames[5])  #  data file path, without filename
      fileName6<-unlist(newNames[6])  #  data fileName without extension
      thisTime<-unlist(newNames[4])
      
      filePath<-dirname(fileName)  #   *****  Set this to the path where data and scripts are found
      fileCollection<-paste(fileName5,fileName6,thisTime,functionName,"CosAll.txt",sep="")    #  path to aggregate output file
      fileCollectionXfrm<-paste(fileName5,fileName6,thisTime,functionName,"CosAllXfrm.txt",sep="")    #  path to aggregate output file
      dirPath<-file.path(filePath,"*.dat")   #  path of all output files for use in copy at end
      fileCollection_r<-paste(fileName5,fileName6,thisTime,functionName,"CosAll.rtf",sep="")    #  path to aggregate output file
      dirPath_r<-file.path(filePath,"*.rtf")   #  path of all output files for use in copy at end
      
      #fileCollection<-file.path(filePath,'StrokeClin-all.txt')    #  path to aggregate output file
      
      #  RefDateTime and Range need to use same formats as time column.  
      #***************************************************************
      dirFiles1<-Sys.glob(dirPath)        #  grab names of all .dat files existing before run - these will NOT be appended to final aggregate file
      dirFiles1_r<-Sys.glob(dirPath_r)        #  grab names of all .rtf files existing before run - these will NOT be appended to final aggregate file
      cat(fileName,"\n")
      
      delim<-getDelim(fileName,header, Skip)
      data <- read.table(fileName,sep=delim, quote="\"",header=header, stringsAsFactors=FALSE)
      dataLen<-length(data[,IDcol])  # how many rows of data total
      subjectNames<-unique(data[,IDcol]) # get all unique subject names
      
      for (sub in subjectNames){
        if (sub==""){
          next
      }
        curSubject<-which(data[,IDcol]==sub)
        curLen<-length(curSubject)  # how many rows of data
        subFileName<-paste(sub,".csv",sep="")
        subFile<-file.path(filePath,subFileName)
        #  the written file will always have headers.  Default is V1, V2, V3, etc
        write.table(data[curSubject,], subFile,row.names=FALSE,quote=FALSE,sep=", ")
        cat("curSubject",curSubject)

          CATCosinorMain(TimeCol=TimeCol,Y=Y, Components=Components, window=window, RefDateTime=RefDateTime,  timeFormat=timeFormat, RangeDateTime=RangeDateTime, Units=Units, dt=dt, Progressive=Progressive, Period=Period,header=TRUE, Skip=Skip, Colors=Colors,Graphics=Graphics,Output=Output,Console=Console,Debug=Debug,IDcol=IDcol,fileName=subFile,functionName=functionName)
          
      }  # loop for all subjects in file
      
      #  put all data into one file
      dirFiles2<-Sys.glob(dirPath)
      newFilesX<-match(dirFiles2,dirFiles1)    #  which files match (existed before run)
      oldFilesX<-which(is.na(newFilesX))         # only want those that were NOT here before run, those will not match, and be NAs
      dirFiles<-dirFiles2[oldFilesX]           #  using indexes to all the NAs, get the actual filename at that index
      file.create(fileCollection)             #  create aggregate file
      file.append(fileCollection,dirFiles)    #  append to file=fileCollection, all files in filePath
      
      # dirFiles2_r<-Sys.glob(dirPath_r)
      # newFilesX_r<-match(dirFiles2_r,dirFiles1_r)    #  which files match (existed before run)
      # oldFilesX_r<-which(is.na(newFilesX_r))         # only want those that were NOT here before run, those will not match, and be NAs
      # dirFiles_r<-dirFiles2_r[oldFilesX_r]           #  using indexes to all the NAs, get the actual filename at that index
      # file.create(fileCollection_r)             #  create aggregate file
      # file.append(fileCollection_r,dirFiles_r)    #  append to file=fileCollection, all files in filePath
      datNewOrder<-NULL

      if (IDcol!="fileName" && Output$bySubject){
        # re-order .dat file output, by subject
        txtReordering<-NULL
        ##########   Sorting Rhythmometric data   ######### 
        txtReordering <- read.table(fileCollection, header=TRUE, sep="\t",stringsAsFactors=FALSE, colClasses =c("Period in Hrs"="integer"), fill=TRUE, skip=FALSE)  # blank.lines.skip=TRUE,na.strings=c(" ","--"))     #  comment.char=headerChar1,
        if (Progressive$Interval > 0 || Components>1) {    ########  if a) serial section or b) multi component ###########
            rhyBySubject<- txtReordering[     #  sort by R/S ro type;  period v;   Y;  subject
                              datNewOrder<-order( txtReordering[,1], txtReordering[,10], txtReordering[,6], txtReordering[,4],method="radix",decreasing=c(FALSE,TRUE,FALSE,FALSE) ),
                            ]
        } else {    ##################  special sort if a) single cosinor or b) LSS (Period$Set==0)   ############
            rhyBySubject<- txtReordering[     #   sort by 1)  R/S ro type;  6) Y;  10) period v, 5) section (SS)v;   4) subject  
                              datNewOrder<-order( txtReordering[,1], txtReordering[,6], txtReordering[,10], txtReordering[,5], txtReordering[,4],method="radix",decreasing=c(FALSE,FALSE,TRUE,TRUE,FALSE) ),
                            ]
        }
        ##########   Sorting Summary data  ######### 
        sumBySubject<- txtReordering[     #########  sort by 1)  R/S ro type;  6) Y;  5) section (SS)v;   4) subject     ############
          datNewOrder<-order( txtReordering[,1], txtReordering[,6], txtReordering[,5], txtReordering[,4],method="radix",decreasing=c(FALSE,FALSE,FALSE,FALSE) ),
                            ]
        summaryHdr<-which(rhyBySubject[,1]=="HdrS")[1]    
        summaryTotHdr<-which(rhyBySubject[,1]=="HdrTot")[1]                                 # Totals header for progressives
        txtReordering<-NULL
        txtReordering <- rbind(rhyBySubject[     #  get rid of the Hdr rows
                                  newOrderR<-which(rhyBySubject[,1]=="R"),
                                  ],
                              rhyBySubject[summaryHdr,],
                              sumBySubject[     #  get rid of the Hdr rows
                                  newOrderS<-which(sumBySubject[,1]=="S"),    #  order by Y, Section decreasing, subject, 
                                  ],
                              rhyBySubject[summaryTotHdr,],
                              sumBySubject[     #  get rid of the Hdr rows
                                newOrderS<-which(sumBySubject[,1]=="STot"),   #   order by Y, (section decreasing), subject
                                ])
        #browser()
        write.table(txtReordering,fileCollectionXfrm,quote=FALSE,row.names=FALSE,sep = "\t")
      }  #  end if IDcol for re-ordering
  }  # else IDCOL<>"fileName"
}
